#ifndef MOO_DOCUMENT_MANAGER_H
#define MOO_DOCUMENT_MANAGER_H

namespace moo {

class Document;
class DocumentWindow;

class DocumentManagerPrivate;
class DocumentManager {
    DocumentManagerPrivate *impl;

    DocumentManager();
    ~DocumentManager();
    static DocumentManager *instance();

public:
    struct WindowFactory {
        virtual DocumentWindow *createWindow() const = 0;
        virtual ~WindowFactory() {}
    };

    static void setWindowFactory(WindowFactory *factory);
    static DocumentWindow *createWindow();
};

}

#endif // MOO_DOCUMENT_MANAGER_H
